 DejaView = {};
 DejaView.panel = CreateFrame( "Frame", "DejaViewPanel", UIParent );
 -- Register in the Interface Addon Options GUI
 -- Set the name for the Category for the Options Panel
 DejaView.panel.name = "DejaView";
 -- Add the panel to the Interface Options
 InterfaceOptions_AddCategory(DejaView.panel);
 
 -- Make a child panel
 -- DejaView.childpanel = CreateFrame( "Frame", "DejaViewChild", DejaView.panel);
 -- DejaView.childpanel.name = "MyChild";
 -- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
 -- DejaView.childpanel.parent = DejaView.panel.name;
 -- Add the child to the Interface Options
 -- InterfaceOptions_AddCategory(DejaView.childpanel);

--Panel Title
local dvtitle=CreateFrame("Frame", "dvtitle", DejaViewPanel)
	dvtitle:SetPoint("TOPLEFT", 5, -5)
	dvtitle:SetScale(2.0)
	dvtitle:SetWidth(150)
	dvtitle:SetHeight(50)
	dvtitle:Show()

local dvtitleFS = dvtitle:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	dvtitleFS:SetText('|cff00c0ffDejaView|r')
	dvtitleFS:SetPoint("TOPLEFT", 0, 0)
	dvtitleFS:SetFont("Fonts\\FRIZQT__.TTF", 10)

 local dvlockcheck = CreateFrame("CheckButton", "DejaViewLockAll", DejaViewPanel, "InterfaceOptionsCheckButtonTemplate")
	dvlockcheck:ClearAllPoints()
	dvlockcheck:SetPoint("TOPLEFT", 25, -50)
	dvlockcheck:SetScale(1.25)
	_G[dvlockcheck:GetName() .. "Text"]:SetText("Lock all frames")
	dvlockcheck:SetChecked(true)
	
local dvresetcheck = CreateFrame("Button", "DVResetButton", DejaViewPanel, "UIPanelButtonTemplate")
	dvresetcheck:ClearAllPoints()
	dvresetcheck:SetPoint("BOTTOMLEFT", 5, 5)
	dvresetcheck:SetScale(1.25)
	dvresetcheck:SetWidth(125)
	dvresetcheck:SetHeight(30)
	_G[dvresetcheck:GetName() .. "Text"]:SetText("Reload UI")
	dvresetcheck:HookScript("OnClick", ReloadUI)
	
--Register Events
local de = CreateFrame("Frame", "DejaErrorFrame")

	de:RegisterEvent("PLAYER_LOGIN")
	de:RegisterEvent("PLAYER_ENTERING_WORLD")
	de:RegisterEvent("ADDON_LOADED")
	de:RegisterEvent("PET_BATTLE_OVER")

--Slash Commands
	SlashCmdList['RELOADUI'] = function() ReloadUI() end
	SLASH_RELOADUI1 = '/rl'

	SlashCmdList["READYCHECK"] = function() DoReadyCheck() end
	SLASH_READYCHECK1 = '/rc'

	SlashCmdList["CHECKROLE"] = function() InitiateRolePoll() end
	SLASH_CHECKROLE1 = '/cr'

--Sell Junk
local g = CreateFrame("Frame")
	g:RegisterEvent("MERCHANT_SHOW")

g:SetScript("OnEvent", function()  
local bag, slot
	for bag = 0, 4 do
		for slot = 0, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
				if link and (select(3, GetItemInfo(link)) == 0) then
					UseContainerItem(bag, slot)
			end
		end
	end
	if(CanMerchantRepair()) then
		local cost = GetRepairAllCost()
		if cost>0 and CanGuildBankRepair() then
			if GetGuildBankWithdrawMoney() > cost then
				RepairAllItems(1)
				print(format("|cfff07100Repair costs covered by Guild Bank: %.2fg|r", cost * 0.0001))
			else
				print("Insufficient Guild Bank funds to cover repair costs.")
			end
		elseif(cost>0 and GetMoney()>cost) then
			RepairAllItems()
			print(format("|cffead000Repair cost: %.2fg|r", cost * 0.0001))
		elseif(GetMoney()<cost) then
			 print("Insufficient funds to cover repair costs.")
		end
	end
end)

--Choonster's Spell Off Cursor Button
local b = CreateFrame("Button", "SpellStopTargetingButton", UIParent, "SecureActionButtonTemplate")
	b:SetAttribute("type", "stop")

-- DV Buff Frame
	MinimapCluster:SetFrameStrata("BACKGROUND")

local dvb = CreateFrame("Frame", "DVBFrame")
	dvb:SetClampedToScreen(true)
	dvb:SetFrameStrata("LOW")
	dvb:SetMovable(true)
	dvb:EnableMouse(true)
	dvb:RegisterForDrag("RightButton")
	dvb:SetPoint("TOPRIGHT", UIPARENT, "TOPRIGHT", posX, posX)
	dvb:SetWidth(200)
	dvb:SetHeight(25)
	dvb:Hide()

local dvbframeFS = dvb:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvbFS = dvb:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvbFS:SetPoint("LEFT",dvb,"LEFT",0,0)
	dvbFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvbFS:SetText("Buffs");
	dvbFS:SetTextColor(1, 1, 1);
	
	dvb:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvb:StartMoving() 
		end 
	end) 
	
	dvb:SetScript("OnDragStop", function(self) 
		dvb:StopMovingOrSizing() 
	end)

local t=dvb:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvb)
	t:SetTexture(0, 192, 255, 0.7)
			
	BuffFrame:SetPoint("TOPRIGHT", dvb, "TOPRIGHT")
	
-- DV Debuff Frame
local dvdbframe=CreateFrame("Frame", "dvdbframe", UIParent)
	dvdbframe:SetFrameStrata("LOW")
	dvdbframe:SetClampedToScreen(true)
	dvdbframe:SetPoint("TOPRIGHT", dvb, "BOTTOMRIGHT", 0, -54)
	dvdbframe:SetMovable(true)
	dvdbframe:EnableMouse(true)
	dvdbframe:RegisterForDrag("RightButton")
	dvdbframe:SetWidth(160)
	dvdbframe:SetHeight(31)

	dvdbframe:RegisterEvent("PLAYER_LOGIN")
	dvdbframe:RegisterEvent("PLAYER_ENTERING_WORLD")
	dvdbframe:RegisterEvent("ADDON_LOADED")
	dvdbframe:RegisterEvent("PET_BATTLE_OVER")
	dvdbframe:RegisterEvent("UNIT_AURA")
	dvdbframe:Hide()

local dvdbframeFS = dvdbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvdbFS = dvdbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvdbFS:SetPoint("LEFT",dvdbframe,"LEFT",0,0)
	dvdbFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvdbFS:SetText("Debuffs");
	dvdbFS:SetTextColor(1, 1, 1);
	
	dvdbframe:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvdbframe:StartMoving() 
		end 
	end)
	
	dvdbframe:SetScript("OnDragStop", function(self) 	
		dvdbframe:StopMovingOrSizing() 
	end)

local t=dvdbframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvdbframe)
	t:SetTexture(0, 192, 255, 0.7)
	
--Move Debuffs
local function movedb(frame,anchorPoint,relativeTo,relativePoint,xoff,yoff)
	frame:ClearAllPoints()
	frame:SetPoint(anchorPoint,relativeTo,relativePoint,xoff,yoff)
end

local function eventHandler(self, event, ...)
	for _,bar in pairs({"DebuffButton"}) do
		for i=2, DEBUFF_MAX_DISPLAY do
			if _G[bar..i] then
				movedb(_G[bar..i],"RIGHT",_G[bar..(i-1)],"LEFT",-2,0)
			end
		end
	end
	for i = 1, DEBUFF_MAX_DISPLAY do
		if DebuffButton1 then
			movedb(DebuffButton1,"BOTTOMRIGHT",dvdbframe,"BOTTOMRIGHT",0,0)
		end
		if DebuffButton6 then
			movedb(DebuffButton6,"BOTTOM",DebuffButton1,"TOP",0,14)
		end
		if DebuffButton11 then
			movedb(DebuffButton11,"BOTTOM",DebuffButton6,"TOP",0,14)
		end
		if DebuffButton16 then
			movedb(DebuffButton16,"BOTTOM",DebuffButton11,"TOP",0,14)
		end
		if DebuffButton21 then
			movedb(DebuffButton21,"BOTTOM",DebuffButton16,"TOP",0,14)
		end
		if DebuffButton26 then
			movedb(DebuffButton26,"BOTTOM",DebuffButton21,"TOP",0,14)
		end
		if DebuffButton31 then
			movedb(DebuffButton31,"BOTTOM",DebuffButton26,"TOP",0,14)
		end
		if DebuffButton36 then
			movedb(DebuffButton36,"BOTTOM",DebuffButton31,"TOP",0,14)
		end
		if DebuffButton41 then
			movedb(DebuffButton41,"BOTTOM",DebuffButton36,"TOP",0,14)
		end
	end
end

dvdbframe:SetScript("OnEvent",eventHandler)

-- Hide Player Frame Icons
local pframe = CreateFrame("Frame", "DejapFrame")
	pframe:SetFrameStrata("BACKGROUND")
	pframe:SetWidth(372)
	pframe:SetHeight(26)
	pframe:SetPoint("CENTER", UIParent, "BOTTOM", 0, 0)
	pframe:Show()

	pframe:RegisterEvent("PLAYER_LOGIN")
	pframe:RegisterEvent("PLAYER_ENTERING_WORLD")
	pframe:RegisterEvent("ADDON_LOADED")
	pframe:RegisterEvent("PLAYER_REGEN_DISABLED")
	pframe:RegisterEvent("PLAYER_REGEN_ENABLED")
	pframe:RegisterEvent("UNIT_COMBAT")
	pframe:RegisterEvent("PET_BATTLE_OVER")

--Move Player/Target/Focus Icons
	PlayerLeaderIcon:SetPoint("TOPLEFT",90,-35);
  	PlayerMasterIcon:SetPoint("TOPLEFT",90,-50);
  	PlayerFrameGroupIndicator:SetPoint("BOTTOMLEFT", PlayerFrame, "TOPLEFT", 97, -40);
	PlayerRestIcon:ClearAllPoints()
   	PlayerRestIcon:SetPoint("RIGHT", PlayerFrame, "RIGHT", 25, 0)
	PlayerPVPIcon:ClearAllPoints()
   	PlayerPVPIcon:SetPoint("LEFT", PlayerFrame, "LEFT", 55, -15)

	TargetFrameTextureFramePVPIcon:ClearAllPoints()
	TargetFrameTextureFramePVPIcon:SetPoint("RIGHT", TargetFrame, "RIGHT", -35, -15)
	TargetFrameTextureFrameLeaderIcon:ClearAllPoints()
	TargetFrameTextureFrameLeaderIcon:SetPoint("RIGHT", TargetFrame, "RIGHT", -90, 7)
	TargetFrameTextureFrameLevelText:ClearAllPoints()
	TargetFrameTextureFrameLevelText:SetPoint("LEFT", TargetFrame, "LEFT", 0, 25)
	TargetFrameTextureFrameRaidTargetIcon:ClearAllPoints()
	TargetFrameTextureFrameRaidTargetIcon:SetPoint("LEFT", TargetFrame, "LEFT", -30, 30)

	TargetFrameToT:ClearAllPoints()
	TargetFrameToT:SetPoint("LEFT", TargetFrame, "LEFT", -35, -35)
	TargetFrameToT:EnableMouse(false)

	FocusFrameTextureFramePVPIcon:ClearAllPoints()
	FocusFrameTextureFramePVPIcon:SetPoint("RIGHT", FocusFrame, "RIGHT", -35, -15)
	FocusFrameTextureFrameLeaderIcon:ClearAllPoints()
	FocusFrameTextureFrameLeaderIcon:SetPoint("RIGHT", FocusFrame, "RIGHT", -90, 7)
	FocusFrameTextureFrameLevelText:ClearAllPoints()
	FocusFrameTextureFrameLevelText:SetPoint("LEFT", FocusFrame, "LEFT", 0, 25)
	FocusFrameTextureFrameRaidTargetIcon:ClearAllPoints()
	FocusFrameTextureFrameRaidTargetIcon:SetPoint("RIGHT", FocusFrame, "RIGHT", -65, 30)

-- Player Frame Combat Fade
	pframe:HookScript("OnEvent", function(self, event, ...)
		if event == "ADDON_LOADED" then
			PlayerFrame:SetAlpha(0.25)
			RuneFrame:SetAlpha(0.25)
		end	
		if event == "PLAYER_REGEN_DISABLED" then
			PlayerFrame:SetAlpha(1)
			RuneFrame:SetAlpha(1)
		elseif event == "PLAYER_REGEN_ENABLED" then
			PlayerFrame:SetAlpha(0.25)
			RuneFrame:SetAlpha(0.25)
		end
				
	end)

--Move Target Frame Debuffs
	hooksecurefunc("TargetFrame_UpdateBuffAnchor", function()
		if TargetFrameBuff1 then
			TargetFrameBuff1:ClearAllPoints()
			TargetFrameBuff1:SetPoint("TOP", UIParent, "CENTER", -48, -30)
		end
	end)

	hooksecurefunc("TargetFrame_UpdateDebuffAnchor", function()
		if TargetFrameDebuff1 then
			TargetFrameDebuff1:ClearAllPoints()
			TargetFrameDebuff1:SetPoint("TOP", UIParent, "CENTER", -52, -150)
		end
	end)

local noop = function() return end

--Hide Player Frame Art
for _, objname in ipairs({
	"PlayerAttackBackground",
	"PlayerAttackGlow",
	"PlayerFrameBackground",
	"PlayerFrameFlash",
	"PlayerFrameTexture",
	"PlayerHitIndicator",
	"PlayerLevelText",
	"PlayerName",
	"PlayerPortrait",
	"PlayerRestGlow",
	"PlayerStatusGlow",
	"PlayerStatusTexture",

	"TargetFrameBackground",
	"TargetFrameFlash",
	"TargetFrameNameBackground",
	"TargetFramePortrait",
	"TargetFrameTextureFrameTexture",

	"FocusFrameBackground",
	"FocusFrameFlash",
	"FocusFrameNameBackground",
	"FocusFramePortrait",
	"FocusFrameTextureFrameTexture",

	"PetAttackModeTexture",
	"PetFrameFlash",
	"PetFrameTexture",
	"PetHitIndicator",
	"PetName",
	"PetPortrait",
}) do
	local obj = _G[objname]
	if obj then
		obj:Hide()
		obj.Show = noop
	end
end

-- Minimap

--Hide Minimap Frames
	MinimapBorder:Hide()
	MinimapBorderTop:Hide()
	MinimapZoomIn:Hide()
	MinimapZoomOut:Hide()
	MinimapNorthTag:Hide()
	MiniMapTracking:SetAlpha(0)

--Hide Minimap Clock
local mm = CreateFrame("Frame", "DejaMinimapFrame")

	mm:RegisterEvent("PLAYER_LOGIN")
	mm:RegisterEvent("PLAYER_ENTERING_WORLD")
	mm:RegisterEvent("ADDON_LOADED")
	mm:RegisterEvent("PET_BATTLE_OVER")
	mm:RegisterEvent("UPDATE_INSTANCE_INFO")

local function eventHandler(self, event, ...)
	for i = 1, 1 do
		if TimeManagerClockButton then
			TimeManagerClockButton:SetAlpha(0)
		end
	end
end

mm:SetScript("OnEvent",eventHandler)

-- Make Minimap Movable
	Minimap:SetFrameStrata("BACKGROUND")
	Minimap:SetMovable(true)
	Minimap:EnableMouse(true)
	Minimap:RegisterForDrag()
	Minimap:SetClampedToScreen(true)
	Minimap:SetScale(0.86)
	Minimap:SetMaskTexture('Interface\\ChatFrame\\ChatFrameBackground')
	Minimap:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
	Minimap:EnableMouseWheel(true)
	
	Minimap:SetScript("OnMouseWheel", function(mp, input)
	local zoom = Minimap:GetZoom()
		if input > 0 and zoom < 5 then
			mp:SetZoom(zoom +1)
		elseif input < 0 and zoom > 0 then
			mp:SetZoom(zoom -1)
		end
	end)

	Minimap:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 
			Minimap:StartMoving() 
		end 
	end)

	Minimap:SetScript("OnDragStop", function(self) 
		Minimap:StopMovingOrSizing() 
	end)

-- Move Minimap Icons
	MiniMapTracking:ClearAllPoints()
	MiniMapTracking:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

	QueueStatusMinimapButton:ClearAllPoints()
	QueueStatusMinimapButton:SetPoint("CENTER", Minimap, "LEFT", 0, 0)

	MiniMapInstanceDifficulty_AdjustPosition = function() end
	MiniMapInstanceDifficulty:SetParent(UIParent)
	MiniMapInstanceDifficulty:SetScale(0.5)
	MiniMapInstanceDifficulty:ClearAllPoints()
	MiniMapInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

	GuildInstanceDifficulty_AdjustPosition = function() end
	GuildInstanceDifficulty:SetParent(UIParent)
	GuildInstanceDifficulty:SetScale(0.5)
	GuildInstanceDifficulty:ClearAllPoints()
	GuildInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

	MiniMapMailBorder:SetAlpha(0)
	MiniMapMailFrame:SetScale(1.25)
	MiniMapMailFrame:ClearAllPoints()
	MiniMapMailFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 7, 5)

	GameTimeFrame:SetAlpha(0)
	GameTimeFrame:ClearAllPoints()
	GameTimeFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 0, 0)

	MiniMapWorldMapButton:SetScale(1.5)
	MiniMapWorldMapButton:SetAlpha(0)
	MiniMapWorldMapButton:ClearAllPoints()
	MiniMapWorldMapButton:SetPoint("TOP", Minimap, "TOP", 0, 10)

	MiniMapRecordingBorder:SetAlpha(0)
	MiniMapRecordingButton:ClearAllPoints()
	MiniMapRecordingButton:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", 0, 0)

--Zone Text
local zoneframe = CreateFrame("Frame", nil, UIParent)
	zoneframe:SetFrameStrata("HIGH")
	zoneframe:SetWidth(100)
	zoneframe:SetHeight(26)
	zoneframe:SetPoint("TOP", Minimap, "TOP")
	zoneframe:Show()

	MinimapZoneTextButton:ClearAllPoints()
	MinimapZoneTextButton:SetPoint("TOP", zoneframe, "TOP", 0, 0)
	MinimapZoneTextButton:SetFrameStrata("HIGH")
	
-- Create New Minimap Clock
local use24hformat = false

local mmclock = CreateFrame("Frame", nil, UIParent)
	mmclock:SetFrameStrata("MEDIUM")
	mmclock:SetWidth(100)
	mmclock:SetHeight(26)
	mmclock:SetPoint("BOTTOM", Minimap, "BOTTOM", 0, 0)
	mmclock:Show()

local clockFS = mmclock:CreateFontString("FontString","OVERLAY","GameTooltipText")

	clockFS:SetPoint("BOTTOM",mmclock,"BOTTOM",0,0)

local elapsed = 0
	mmclock:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
	   if elapsed >= 1 then
		   MinimapClockRefresh()
		   elapsed = 0
	   end
end)

	mmclock:SetScript("OnEvent", function()
		   clockFS:SetTextColor(1, 1, 1);
		   MinimapClockRefresh()
	end)

function MinimapClockRefresh()
	if use24hformat then
		clockFS:SetFont("Fonts\\FRIZQT__.TTF", 12, "THINOUTLINE")
		clockFS:SetText(date("%H:%M"))
	else
		clockFS:SetFont("Fonts\\FRIZQT__.TTF", 12, "THINOUTLINE")
		clockFS:SetText(("%d:%s"):format(tonumber(date("%I")),((date("%M%p")))))
	end
end

-- Minimap Coordinates
local coordframe = CreateFrame("Frame", nil, UIParent)
	coordframe:SetFrameStrata("MEDIUM")
	coordframe:SetWidth(100)
	coordframe:SetHeight(26)
	coordframe:SetPoint("TOP", MinimapZoneTextButton, "BOTTOM", 0, 0)
	coordframe:Show()

local elapsed = 0
local coordframeFS = coordframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local coordFS = coordframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
function coordRefresh()
	local posX, posY = GetPlayerMapPosition("player")
		coordFS:SetFont("Fonts\\FRIZQT__.TTF", 12, "THINOUTLINE")
		coordFS:SetFormattedText("%.1f, %.1f", posX*100, posY*100)
end

	coordFS:SetPoint("TOP",coordframe,"TOP",0,0)

	coordframe:SetScript("OnEvent", function()
		   coordFS:SetTextColor(1, 1, 1);
		   coordRefresh()
	end)
	
	coordframe:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
	   if elapsed >= 1 then
		   coordRefresh()
		   elapsed = 0
	   end
	end)
	
-- Main Menu Bars

--Hide Main Bar Art
		MainMenuBarLeftEndCap:Hide()
		MainMenuBarRightEndCap:Hide()

		MainMenuBarTexture0:Hide()
		MainMenuBarTexture1:Hide()
		MainMenuBarTexture2:Hide()
		MainMenuBarTexture3:Hide()	
		
		MainMenuMaxLevelBar0:Hide()
		MainMenuMaxLevelBar1:Hide()
		MainMenuMaxLevelBar2:Hide()
		MainMenuMaxLevelBar3:Hide()

		StanceBarLeft:SetAlpha(0)
		StanceBarMiddle:SetAlpha(0)
		StanceBarRight:SetAlpha(0)

		SlidingActionBarTexture0:SetAlpha(0)
		SlidingActionBarTexture1:SetAlpha(0)	 
		
		ExhaustionLevelFillBar:Hide()
		MainMenuXPBarTextureLeftCap:Hide()
		MainMenuXPBarTextureRightCap:Hide()
		MainMenuXPBarTextureMid:Hide()
		
		MainMenuBarMaxLevelBar:Hide()

		MainMenuMaxLevelBar0:Hide()
		MainMenuMaxLevelBar1:Hide()
		MainMenuMaxLevelBar2:Hide()
		MainMenuMaxLevelBar3:Hide()

		ReputationWatchBarTexture0:SetAlpha(0);
		ReputationWatchBarTexture1:SetAlpha(0);
		ReputationWatchBarTexture2:SetAlpha(0);
		ReputationWatchBarTexture3:SetAlpha(0);

		ReputationXPBarTexture0:SetAlpha(0);
		ReputationXPBarTexture1:SetAlpha(0);
		ReputationXPBarTexture2:SetAlpha(0);
		ReputationXPBarTexture3:SetAlpha(0);

		SpellActivationOverlayFrame:Hide()
		
--Hide XP Bar Art
	for i = 1, 19 do
		local texture = _G["MainMenuXPBarDiv"..i]
			if texture then
				texture:SetAlpha(0)
		end
	end
	
-- DVMainBarFrame to center the main bar on
local mbars=CreateFrame("Frame", "mbars", UIParent)
	mbars:SetClampedToScreen(true)
	mbars:SetPoint("BOTTOM", UIParent, "BOTTOM")
	mbars:SetSize(476,36)

-- DVPetFrame
local dvpetframe=CreateFrame("Frame", "dvpetframe", UIParent)
	dvpetframe:SetFrameStrata("BACKGROUND")
	dvpetframe:SetClampedToScreen(true)
	dvpetframe:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6)
	dvpetframe:SetMovable(true)
	dvpetframe:EnableMouse(true)
	dvpetframe:RegisterForDrag("RightButton")
	dvpetframe:SetWidth(318)
	dvpetframe:SetHeight(38)
	dvpetframe:Hide()

local dvpetframeFS = dvpetframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvpetFS = dvpetframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvpetFS:SetPoint("TOP",dvpetframe,"TOP",0,10)
	dvpetFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvpetFS:SetText("Pet Action Bar");
	dvpetFS:SetTextColor(1, 1, 1);
	
	dvpetframe:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvpetframe:StartMoving() 
			end 
		end)
	dvpetframe:SetScript("OnDragStop", function(self) 
		dvpetframe:StopMovingOrSizing() 
	end)

	local t=dvpetframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvpetframe)
	t:SetTexture(0, 192, 255, 0.7)

-- DVStanceFrame
local dvstanceframe=CreateFrame("Frame", "dvstanceframe", UIParent)
	dvstanceframe:SetFrameStrata("BACKGROUND")
	dvstanceframe:SetClampedToScreen(true)
	dvstanceframe:SetPoint("BOTTOMLEFT", dvpetframe, "TOPLEFT", 0, 6)
	dvstanceframe:SetMovable(true)
	dvstanceframe:EnableMouse(true)
	dvstanceframe:RegisterForDrag("RightButton")
	dvstanceframe:SetWidth(190)
	dvstanceframe:SetHeight(38)
	dvstanceframe:Hide()
	
local dvstanceframeFS = dvstanceframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvstanceFS = dvstanceframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvstanceFS:SetPoint("TOP",dvstanceframe,"TOP",0,10)
	dvstanceFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvstanceFS:SetText("Stance Action Bar");
	dvstanceFS:SetTextColor(1, 1, 1);
	
	dvstanceframe:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvstanceframe:StartMoving() 
		end 
	end)
	dvstanceframe:SetScript("OnDragStop", function(self) 	
		dvstanceframe:StopMovingOrSizing() 
	end)

	local t=dvstanceframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvstanceframe)
	t:SetTexture(0, 192, 255, 0.7)
	
-- DVRightSideBarsFrame
local dvrsbframe=CreateFrame("Frame", "dvrsbframe", UIParent)
	dvrsbframe:SetFrameStrata("BACKGROUND")
	dvrsbframe:SetClampedToScreen(true)
	dvrsbframe:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMLEFT", 0, 0)
	dvrsbframe:SetMovable(true)
	dvrsbframe:EnableMouse(true)
	dvrsbframe:RegisterForDrag("RightButton")
	dvrsbframe:SetWidth(191)
	dvrsbframe:SetHeight(121)
	dvrsbframe:Hide()
local dvrsbframeFS = dvrsbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvrsbFS = dvrsbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvrsbFS:SetPoint("TOP",dvrsbframe,"TOP",0,0)
	dvrsbFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvrsbFS:SetText("Right Side Action Bars");
	dvrsbFS:SetTextColor(1, 1, 1);
	
	dvrsbframe:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvrsbframe:StartMoving() 
			end 
		end)
	dvrsbframe:SetScript("OnDragStop", function(self) 
		dvrsbframe:StopMovingOrSizing() 
	end)

	local t=dvrsbframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvrsbframe)
	t:SetTexture(0, 192, 255, 0.7)

-- DVBottom Texture
local dbtexture=CreateFrame("Frame", "dbtexture", UIParent)
	dbtexture:SetClampedToScreen(1)
	dbtexture:SetFrameStrata(BACKGROUND)
	dbtexture:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT")
	dbtexture:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
	dbtexture:SetHeight(121)

local t=dbtexture:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dbtexture)
	t:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background")

local mbarspagenumber=CreateFrame("Frame", "MBarsPageNumber", UIParent)
	mbarspagenumber:SetClampedToScreen(1)
	mbarspagenumber:SetFrameStrata(HIGH)
	mbarspagenumber:SetPoint("BOTTOM", mbars, "BOTTOM")
	mbarspagenumber:SetSize(10,36)

local function move(frame,anchorPoint,relativeTo,relativePoint,xoff,yoff)
	frame:ClearAllPoints()
	frame:SetPoint(anchorPoint,relativeTo,relativePoint,xoff,yoff)
end

-- Position anchor buttons for each bar
	move(ActionButton1,"BOTTOMLEFT",mbars,"BOTTOMLEFT",0,0)
	move(MultiBarBottomLeftButton1,"BOTTOMLEFT",ActionButton1,"TOPLEFT",0,6)
	move(MultiBarBottomRightButton1,"BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,6)
	move(MultiBarRightButton12,"BOTTOMRIGHT", dvrsbframe, "BOTTOMRIGHT", 0, 0)
	move(MultiBarLeftButton12,"BOTTOMRIGHT", MultiBarRightButton4, "BOTTOMLEFT", 0, 0)
	move(PetActionButton1,"BOTTOMLEFT", dvpetframe, "BOTTOMLEFT", 0, 0) 
	move(StanceButton1,"BOTTOMLEFT", dvstanceframe, "BOTTOMLEFT", 0, 0)

-- Anchor buttons 2-12 for each bar
	for _,bar in pairs({"ActionButton","MultiBarBottomLeftButton","MultiBarBottomRightButton"}) do
		for i=2,12 do
			move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",4,0)
		end
	end

-- Anchor buttons for right side bars
	for _,bar in pairs({"MultiBarRightButton","MultiBarLeftButton"}) do
		for i=1,12 do
			v =_G[bar..i]
			v:SetScale(0.84)
		end
		for i=11,9, -1 do
			move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
		end
		for i=8,5, -1 do
			move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
		end
		for i=4,1, -1 do
			move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
		end
		for i=8,4, -4 do
			move(_G[bar..i],"RIGHT",_G[bar..(i+4)],"LEFT",0,0)
		end
	end

-- Anchor buttons 2-10 for Pet Action bar
	for _,bar in pairs({"PetActionButton"}) do
		for i=2,10 do
			move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",2,0)
		end
	end
	
-- Anchor buttons 2-10 for Stance bar
	for _,bar in pairs({"StanceButton"}) do
		for i=2,10 do
			move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",2,0)
		end
	end
	
-- Action Bar Up/Down buttons
	move(MainMenuBarPageNumber,"CENTER",mbars,"CENTER",0,0)
	ActionBarUpButton:Hide()
	ActionBarDownButton:Hide()
	
-- DVMicroMenuFrame
local dvmmframe=CreateFrame("Frame", "dvmmframe", UIParent)
	dvmmframe:SetFrameStrata("HIGH")
	dvmmframe:SetClampedToScreen(true)
	dvmmframe:SetPoint("BOTTOMRIGHT", Minimap, "TOPRIGHT", dvmmdefault)
	dvmmframe:SetMovable(true)
	dvmmframe:EnableMouse(true)
	dvmmframe:RegisterForDrag("RightButton")
	dvmmframe:SetWidth(312)
	dvmmframe:SetHeight(36)
	dvmmframe:Hide()
	
local dvmmframeFS = dvmmframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvmmFS = dvmmframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvmmFS:SetPoint("CENTER",dvmmframe,"CENTER",0,0)
	dvmmFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvmmFS:SetText("Micro Menu Buttons");
	dvmmFS:SetTextColor(1, 1, 1);
	
	dvmmframe:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvmmframe:StartMoving() 
			end 
		end)
	dvmmframe:SetScript("OnDragStop", function(self) 
		dvmmframe:StopMovingOrSizing() 
	end)

	local t=dvmmframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvmmframe)
	t:SetTexture(0, 192, 255, 0.7)
	
-- Move Micro Buttons Anchor
	move(CharacterMicroButton,"BOTTOMLEFT",dvmmframe,"BOTTOMLEFT",27,-1)

-- Micro Buttons Mouse Fade
local ignorealpha

local function setAlpha(b, a)
	if ignorealpha then return end
	ignorealpha = true
	if b:IsMouseOver() then
		b:SetAlpha(1)
	else
		b:SetAlpha(0)
	end
	ignorealpha = nil
end

local function showMMB(self)
    for _, v in ipairs(MICRO_BUTTONS) do
        ignorealpha = true
        _G[v]:SetAlpha(1)
        ignorealpha = nil
    end
end
 
local function hideMMB(self)
    for _, v in ipairs(MICRO_BUTTONS) do
        ignorealpha = true
        _G[v]:SetAlpha(0)
        ignorealpha = nil
    end
end
 
for _, v in ipairs(MICRO_BUTTONS) do
    v = _G[v]
    hooksecurefunc(v, "SetAlpha", setAlpha)
    v:HookScript("OnEnter", showMMB)
    v:HookScript("OnLeave", hideMMB)
    v:SetAlpha(0)
end
	
-- XP/Rep Bar
	MainMenuExpBar:SetSize(476,6)
	MainMenuBarMaxLevelBar:SetSize(476,6)
	ReputationWatchStatusBar:SetAllPoints(ReputationWatchBar)

-- Move XP Bar Anchor
	move(MainMenuExpBar,"BOTTOMLEFT",ActionButton1,"TOPLEFT",0,0)
	move(MainMenuBarMaxLevelBar,"BOTTOMLEFT",ActionButton1,"TOPLEFT",0,0)

local maxlevel = GetMaxPlayerLevel()	
local level = UnitLevel("player")

-- SetPoint expects (self,anchorPoint,relativeTo,relativePoint,xoff,yoff)
-- to prevent this hook calling itself, we attach a custom flag at the end
-- so it knows when not to react to the SetPoint.
	hooksecurefunc(ReputationWatchBar,"SetPoint",function(self,_,_,_,_,_,flag)
		if flag~="mbars" then
			self:ClearAllPoints()
				if level==maxlevel then
					self:SetPoint("BOTTOMLEFT",ActionButton1,"TOPLEFT",0,0,"mbars")
					self:SetSize(476,6)
				else
					self:SetPoint("BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,0,"mbars")
					self:SetSize(476,6)
				end
		end
	end)
	
-- DV Bag Buttons Mouseover Fade
local dvbagframe=CreateFrame("Frame", "dvbagframe", UIParent)
	dvbagframe:SetFrameStrata("BACKGROUND")
	dvbagframe:SetClampedToScreen(true)
	dvbagframe:SetPoint("BOTTOMRIGHT", dvrsbframe, "BOTTOMLEFT")
	dvbagframe:SetMovable(true)
	dvbagframe:EnableMouse(true)
	dvbagframe:RegisterForDrag("RightButton")
	dvbagframe:SetWidth(158)
	dvbagframe:SetHeight(50)
	dvbagframe:Hide()

local dvbagframeFS = dvbagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvbagFS = dvbagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvbagFS:SetPoint("TOP",dvbagframe,"TOP",0,0)
	dvbagFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvbagFS:SetText("Bags");
	dvbagFS:SetTextColor(1, 1, 1);
	
	dvbagframe:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvbagframe:StartMoving() 
		end 
	end)
	dvbagframe:SetScript("OnDragStop", function(self) 	
	dvbagframe:StopMovingOrSizing() 
	end)

local t=dvbagframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvbagframe)
	t:SetTexture(0, 192, 255, 0.7)
	
local function showDVBB(self)
	MainMenuBarBackpackButton:SetAlpha(1)
	CharacterBag0Slot:SetAlpha(1)
	CharacterBag1Slot:SetAlpha(1)
	CharacterBag2Slot:SetAlpha(1)
	CharacterBag3Slot:SetAlpha(1)
end
     
local function hideDVBB(self)
	MainMenuBarBackpackButton:SetAlpha(0)
	CharacterBag0Slot:SetAlpha(0)
	CharacterBag1Slot:SetAlpha(0)
	CharacterBag2Slot:SetAlpha(0)
	CharacterBag3Slot:SetAlpha(0)
end

	MainMenuBarBackpackButton:HookScript("OnEnter", showDVBB)
	CharacterBag0Slot:HookScript("OnEnter", showDVBB)
	CharacterBag1Slot:HookScript("OnEnter", showDVBB)
	CharacterBag2Slot:HookScript("OnEnter", showDVBB)
	CharacterBag3Slot:HookScript("OnEnter", showDVBB)
	
	MainMenuBarBackpackButton:HookScript("OnLeave", hideDVBB)
	CharacterBag0Slot:HookScript("OnLeave", hideDVBB)
	CharacterBag1Slot:HookScript("OnLeave", hideDVBB)
	CharacterBag2Slot:HookScript("OnLeave", hideDVBB)
	CharacterBag3Slot:HookScript("OnLeave", hideDVBB)

	MainMenuBarBackpackButton:SetAlpha(0)
	CharacterBag0Slot:SetAlpha(0)
	CharacterBag1Slot:SetAlpha(0)
	CharacterBag2Slot:SetAlpha(0)
	CharacterBag3Slot:SetAlpha(0)	
	
-- Bag Buttons
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", dvbagframe, "BOTTOMRIGHT", 0, 0)
	
	MainMenuBarBackpackButton:HookScript("OnEnter", showDVBB)
	MainMenuBarBackpackButton:HookScript("OnLeave", hideDVBB)
	MainMenuBarBackpackButton:SetAlpha(0)
	
	CharacterBag0Slot:HookScript("OnEnter", showDVBB)
	CharacterBag0Slot:HookScript("OnLeave", hideDVBB)
	CharacterBag0Slot:SetAlpha(0)
	
	CharacterBag1Slot:HookScript("OnEnter", showDVBB)
	CharacterBag1Slot:HookScript("OnLeave", hideDVBB)
	CharacterBag1Slot:SetAlpha(0)
	
	CharacterBag2Slot:HookScript("OnEnter", showDVBB)
	CharacterBag2Slot:HookScript("OnLeave", hideDVBB)
	CharacterBag2Slot:SetAlpha(0)
	
	CharacterBag3Slot:HookScript("OnEnter", showDVBB)
	CharacterBag3Slot:HookScript("OnLeave", hideDVBB)
	CharacterBag3Slot:SetAlpha(0)
	
-- Information Stat Frame
local statframep = CreateFrame("Frame", "StatFrameParent", UIParent)
	statframep:SetMovable(true) -- this and following 3 lines make window movable with mouse
	statframep:EnableMouse(true)
	statframep:RegisterForDrag("RightButton")
	statframep:SetClampedToScreen(true)
	statframep:SetFrameStrata("BACKGROUND")
	statframep:SetPoint("BOTTOMRIGHT", dvrsbframe, "BOTTOMLEFT")
	statframep:SetSize(158,40)
	statframep:Hide()
	
local statframe = CreateFrame("Frame", "StatFrame", UIParent)
	statframe:SetMovable(true) -- this and following 3 lines make window movable with mouse
	statframe:EnableMouse(true)
	statframe:RegisterForDrag("RightButton")
	statframe:SetClampedToScreen(true)
	statframe:SetFrameStrata("BACKGROUND")
	statframe:SetPoint("BOTTOM", statframep, "BOTTOM")
	statframe:SetSize(158,25)
	
	statframe:RegisterEvent("ZONE_CHANGED")
	statframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	statframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local statframeFS = statframep:CreateFontString("FontString","OVERLAY","GameTooltipText")
local statFS = statframep:CreateFontString("FontString","OVERLAY","GameTooltipText")

	statFS:SetPoint("TOP",statframep,"TOP",0,0)
	statFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	statFS:SetText("Stats Frame");
	statFS:SetTextColor(1, 1, 1);
	
	statframep:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" and IsAltKeyDown() and not self.isMoving then
			self:StartMoving()
			self.isMoving = true
		end
	end)

	statframep:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and self.isMoving then
			self:StopMovingOrSizing()
			self.isMoving = false
		end
	end)

local tstatframe=statframep:CreateTexture(nil,"ARTWORK")
	tstatframe:SetAllPoints(statframep)
	tstatframe:SetTexture(0, 192, 255, 0.7)
	
--Gold
local goldframe = CreateFrame("Frame", nil, statframe)
	goldframe:SetFrameStrata("BACKGROUND")
	goldframe:SetWidth(50)
	goldframe:SetHeight(10)
	goldframe:SetPoint("BOTTOMRIGHT", statframe, "BOTTOMRIGHT", 0, 0)
	goldframe:Show()

	goldframe:RegisterEvent("ZONE_CHANGED")
	goldframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	goldframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local goldframeFS = goldframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local goldFS = goldframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	goldFS:SetPoint("BOTTOMRIGHT",goldframe,"BOTTOMRIGHT",0,0)
	goldFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

goldframe:SetScript("OnUpdate", function(self, e)
	elapsed = elapsed + e
		if elapsed >= 1 then
			goldRefresh()
			elapsed = 0
		end
end)

	goldframe:SetScript("OnEvent", function()
		   goldFS:SetTextColor(1, 1, 1);
		   goldRefresh()
	end)

function goldRefresh()
	local gold = GetMoney()
		if (gold>9999999) then
			goldFS:SetFormattedText("%.0fg", (gold/10000))
		end
		if (gold<10000000) then
			goldFS:SetFormattedText("%.2fg", (gold/10000))
		
		end
		if (gold<10000) then
			goldFS:SetFormattedText("%.2fs", (gold/100))
		end
		if (gold<100) then
			goldFS:SetFormattedText("%.0fc", gold)
		end
end

--Bags Remaining
local Bagframe = CreateFrame("Frame", nil, statframe)
	Bagframe:SetFrameStrata("BACKGROUND")
	Bagframe:SetWidth(50)
	Bagframe:SetHeight(10)
	Bagframe:SetPoint("BOTTOM", statframe, "BOTTOM", 0, 0)
	Bagframe:Show()

	Bagframe:RegisterEvent("ZONE_CHANGED")
	Bagframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	Bagframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local BagframeFS = Bagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local BagFS = Bagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	BagFS:SetPoint("BOTTOM",Bagframe,"BOTTOM",0,0)
	BagFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	Bagframe:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
	   if elapsed >= 1 then
		   BagRefresh()
		   elapsed = 0
	   end
	end)

	Bagframe:SetScript("OnEvent", function()
		   BagFS:SetTextColor(1, 1, 1);
		   BagRefresh()
	end)

function BagRefresh()
	local bagRem, bagTtl = 0, 0
		for i = 0, NUM_BAG_SLOTS do
			bagRem, bagTtl = bagRem + GetContainerNumFreeSlots(i), bagTtl + GetContainerNumSlots(i)
		end

	BagFS:SetFormattedText("B:%.0f", bagRem)
end

--Durability
local duraframe = CreateFrame("Frame", nil, statframe)
	duraframe:SetFrameStrata("BACKGROUND")
	duraframe:SetWidth(50)
	duraframe:SetHeight(10)
	duraframe:SetPoint("BOTTOMLEFT", statframe, "BOTTOMLEFT", 0, 0)
	duraframe:Show()

	duraframe:RegisterEvent("ZONE_CHANGED")
	duraframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	duraframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local duraframeFS = duraframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local duraFS = duraframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	duraFS:SetPoint("BOTTOMLEFT",duraframe,"BOTTOMLEFT",0,0)
	duraFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0
	duraframe:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
		   if elapsed >= 1 then
				duraRefresh()
				elapsed = 0
		   end
end)

	duraframe:SetScript("OnEvent", function()
		duraFS:SetTextColor(1, 1, 1);
		duraRefresh()
	end)

function duraRefresh()
	local durFull = true
		for slot, slotName in gmatch("1HEAD3SHOULDER5CHEST6WAIST7LEGS8FEET9WRIST10HANDS16MAINHAND17SECONDARYHAND18RANGED","(%d+)([^%d]+)") do
			local durCur, durMax = GetInventoryItemDurability(slot)
			local slotName = _G[slotName.."SLOT"]
				if ( durCur ~= durMax ) then
					duraFS:SetFormattedText("D:%.0f%%", durCur*(100/durMax))
				if ( durFull ) then 
				durFull = false 
				end
				end
		end
			
				if ( durFull ) then
					duraFS:SetText("D:100%")
				end
end

--Addon Memory
local show_mem = true
local addonframe = CreateFrame("Frame", nil, statframe)
	addonframe:SetFrameStrata("BACKGROUND")
	addonframe:SetWidth(50)
	addonframe:SetHeight(10)
	addonframe:SetPoint("TOPRIGHT", statframe, "TOPRIGHT", 0, 0)
	addonframe:Show()

	addonframe:RegisterEvent("ZONE_CHANGED")
	addonframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	addonframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local addonframeFS = addonframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local addonFS = addonframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	addonFS:SetPoint("TOPRIGHT",addonframe,"TOPRIGHT",0,0)
	addonFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	addonframe:SetScript("OnUpdate", function(self, e)
		elapsed = elapsed + e
			if elapsed >= 1 then
				addonRefresh()
				elapsed = 0
			end
	end)

	addonframe:SetScript("OnEvent", function()
		   addonFS:SetTextColor(1, 1, 1);
		   addonRefresh()
	end)

function addonRefresh()
	if show_mem == true then
		local memory = 0
			UpdateAddOnMemoryUsage()
				for i = 1, GetNumAddOns() do
					if IsAddOnLoaded(i) then
						memory = memory + GetAddOnMemoryUsage(i)
					end
				end			
			mem = "|c00ffffff"..format("%.2f", memory / 1024).."|rMB"
	else
		mem = ""
	end
	addonFS:SetText(mem)
end

--Latency
local latencyframe = CreateFrame("Frame", nil, statframe)
	latencyframe:SetFrameStrata("BACKGROUND")
	latencyframe:SetWidth(50)
	latencyframe:SetHeight(10)
	latencyframe:SetPoint("TOP", statframe, "TOP", 0, 0)
	latencyframe:Show()

	latencyframe:RegisterEvent("ZONE_CHANGED")
	latencyframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	latencyframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local latencyframeFS = latencyframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local latencyFS = latencyframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	latencyFS:SetPoint("TOP",latencyframe,"TOP",0,0)
	latencyFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	latencyframe:SetScript("OnUpdate", function(self, e)
		elapsed = elapsed + e
			if elapsed >= 1 then
				latencyRefresh()
				elapsed = 0
			end
	end)

	latencyframe:SetScript("OnEvent", function()
		latencyFS:SetTextColor(1, 1, 1);
		latencyRefresh()
	end)

function latencyRefresh()
	bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
	latencyFS:SetFormattedText("%.0fms", latencyWorld)
end

--Framerate
local fpsframe = CreateFrame("Frame", nil, statframe)
	fpsframe:SetFrameStrata("BACKGROUND")
	fpsframe:SetWidth(50)
	fpsframe:SetHeight(12)
	fpsframe:SetPoint("TOPLEFT", statframe, "TOPLEFT", 0, 0)
	fpsframe:Show()

	fpsframe:RegisterEvent("ZONE_CHANGED")
	fpsframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	fpsframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local fpsframeFS = fpsframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	fpsframeFS:SetPoint("TOPLEFT",fpsframe,"TOPLEFT",0,0)
	fpsframeFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	fpsframe:SetScript("OnUpdate", function(self, e)
		elapsed = elapsed + e
			if elapsed >= 1 then
				fpsframeRefresh()
				elapsed = 0
			end
	end)

	fpsframe:SetScript("OnEvent", function()
		fpsframeFS:SetTextColor(1, 1, 1);
		fpsframeRefresh()
	end)

function fpsframeRefresh()
	local framerate = GetFramerate()
		fpsframeFS:SetFormattedText("%.0ffps", framerate)
end

-- DVGameTooltip
local dvgttframe=CreateFrame("Frame", "dvgttframe", UIParent)
	dvgttframe:SetFrameStrata("BACKGROUND")
	dvgttframe:SetClampedToScreen(true)
	dvgttframe:SetPoint("RIGHT", UIParent, "RIGHT", 0, 0)
	dvgttframe:SetMovable(true)
	dvgttframe:EnableMouse(true)
	dvgttframe:RegisterForDrag("RightButton")
	dvgttframe:SetWidth(160)
	dvgttframe:SetHeight(90)
	dvgttframe:Hide()

local dvgttframeFS = dvgttframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvgttFS = dvgttframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvgttFS:SetPoint("TOP",dvgttframe,"TOP",0,16)
	dvgttFS:SetFont("Fonts\\FRIZQT__.TTF", 16, "THINOUTLINE")
	dvgttFS:SetText("Tooltip");
	dvgttFS:SetTextColor(1, 1, 1);
			
	dvgttframe:SetScript("OnDragStart", function(self) 
		if IsAltKeyDown() then 	
			dvgttframe:StartMoving() 
			end 
		end)
	dvgttframe:SetScript("OnDragStop", function(self) 
		dvgttframe:StopMovingOrSizing() 
	end)

	local t=dvgttframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvgttframe)
	t:SetTexture(0, 192, 255, 0.7)

	hooksecurefunc("GameTooltip_SetDefaultAnchor", function(self, parent)
		self:SetOwner(parent, "ANCHOR_NONE")
		self:ClearAllPoints()
		self:SetPoint("RIGHT", dvgttframe, "RIGHT", 0, 0)
	end)
	
-- Deja Chat
CHAT_FRAME_FADE_OUT_TIME = 0
CHAT_TAB_HIDE_DELAY = 0
CHAT_FRAME_TAB_SELECTED_MOUSEOVER_ALPHA = 1
CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 0
CHAT_FRAME_TAB_ALERTING_MOUSEOVER_ALPHA = 1
CHAT_FRAME_TAB_ALERTING_NOMOUSE_ALPHA = 0
CHAT_FRAME_TAB_NORMAL_MOUSEOVER_ALPHA = 1
CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0

BNToastFrame:SetClampedToScreen(true)

ChatFrameMenuButton:HookScript("OnShow", ChatFrameMenuButton.Hide)
ChatFrameMenuButton:Hide()

FriendsMicroButton:HookScript("OnShow", FriendsMicroButton.Hide)
FriendsMicroButton:Hide()

-- Table to keep track of frames you already saw:
local frames = {}

-- Function to handle customzing a chat frame:
local function ProcessFrame(frame)
	if frames[frame] then return end

	frame:SetClampRectInsets(0, 0, 0, 0)
	frame:SetMaxResize(UIParent:GetWidth(), UIParent:GetHeight())
	frame:SetMinResize(250, 100)

	local name = frame:GetName()
	_G[name .. "ButtonFrame"]:Hide()
	_G[name .. "EditBoxLeft"]:Hide()
	_G[name .. "EditBoxMid"]:Hide()
	_G[name .. "EditBoxRight"]:Hide()

	local editbox = _G[name .. "EditBox"]
	editbox:ClearAllPoints()
	editbox:SetPoint('BOTTOMLEFT', ChatFrame1, 'TOPLEFT', -7, 25)
	editbox:SetPoint('BOTTOMRIGHT', ChatFrame1, 'TOPRIGHT', 10, 25) 
	editbox:SetAltArrowKeyMode(false)

	frames[frame] = true
end

-- Get all of the permanent chat windows and customize them:
for i = 1, NUM_CHAT_WINDOWS do
	ProcessFrame(_G["ChatFrame" .. i])
end

-- Set up a dirty hook to catch temporary windows and customize them when they are created:
local old_OpenTemporaryWindow = FCF_OpenTemporaryWindow
FCF_OpenTemporaryWindow = function(...)
	local frame = old_OpenTemporaryWindow(...)
	ProcessFrame(frame)
	return frame
end

function FloatingChatFrame_OnMouseScroll(self, delta)
	if delta > 0 then
		if IsShiftKeyDown() then
			self:ScrollToTop()
		else	
			self:ScrollUp()
		end
	elseif delta < 0 then
		if IsShiftKeyDown() then
			self:ScrollToBottom()
		else
			self:ScrollDown()
		end
	end	
end

-- Deja PRFader
local function WaitForMouseToGoAway(self)
	if not self:IsMouseOver() then
		self:SetScript("OnUpdate", nil)
		self:SetAlpha(0)
	end
end

CompactRaidFrameManager:HookScript("OnEnter", function(self)
	self:SetScript("OnUpdate", nil)
	self:SetAlpha(1)
end)

CompactRaidFrameManager:HookScript("OnLeave", function(self)
	if self.collapsed then
		self:SetScript("OnUpdate", WaitForMouseToGoAway)
	end
end)

local function CheckMouseOver(self)
	if self:IsMouseOver() and not self.collapsed then
		self:GetScript("OnEnter")(self)
	else
		self:GetScript("OnLeave")(self)
	end
end

hooksecurefunc("CompactRaidFrameManager_Collapse", CheckMouseOver)
hooksecurefunc("CompactRaidFrameManager_Expand", CheckMouseOver)

CompactRaidFrameManager:HookScript("OnShow", CheckMouseOver)

CompactRaidFrameContainer:HookScript("OnEvent", function(self)
	self:SetParent(UIParent)
end)

-- DejaMark
BINDING_HEADER_DEJAMARK = "DejaMark"
_G["BINDING_NAME_CLICK DejaMark:LeftButton"] = "Show Markers (Hold)"

local DejaMarkFrame=CreateFrame("Frame","MyParent",UIParent)
	DejaMarkFrame:SetSize(100,100)
	DejaMarkFrame:SetPoint("CENTER")

local t=DejaMarkFrame:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(DejaMarkFrame)
	t:SetTexture(0, 0, 0, 0.7)

	DejaMarkFrame:Hide()

--Star Marks Raid Marker 1; World Marker 5
local WMStar = CreateFrame("BUTTON", "WorldMarker5Star",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMStar:SetSize(32,32)
     	WMStar:SetPoint("TOPLEFT")
     	WMStar:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_1.png")
	WMStar:SetAlpha(0.5)
    	WMStar:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMStar:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMStar:RegisterForClicks("AnyUp")
	
	WMStar:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMStar:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",1) end\n/wm [btn:2] 5')

--Circle Marks Raid Marker 2; NO World Marker
local WMCircle = CreateFrame("BUTTON", "RaidMarker2Circle",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMCircle:SetSize(32,32)
     	WMCircle:SetPoint("TOP")
     	WMCircle:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_2.png")
	WMCircle:SetAlpha(0.5)
    	WMCircle:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMCircle:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMCircle:RegisterForClicks("AnyUp")
	
	WMCircle:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMCircle:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",2) end\n/wm [btn:2] 0')

--Diamond Marks Raid Marker 3; World Marker 3
local WMDiamond = CreateFrame("BUTTON", "WorldMarker3Diamond",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMDiamond:SetSize(32,32)
     	WMDiamond:SetPoint("TOPRIGHT")
     	WMDiamond:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_3.png")
	WMDiamond:SetAlpha(0.5)
    	WMDiamond:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMDiamond:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMDiamond:RegisterForClicks("AnyUp")
	
	WMDiamond:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMDiamond:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",3) end\n/wm [btn:2] 3')

--Triangle Marks Raid Marker 4; World Marker 2
local WMTriangle = CreateFrame("BUTTON", "WorldMarker2Triangle",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMTriangle:SetSize(32,32)
     	WMTriangle:SetPoint("LEFT")
     	WMTriangle:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_4.png")
	WMTriangle:SetAlpha(0.5)
    	WMTriangle:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMTriangle:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMTriangle:RegisterForClicks("AnyUp")
	
	WMTriangle:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMTriangle:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",4) end\n/wm [btn:2] 2')

--Skull Marks Raid Marker 8; NO World Marker
local WMSkull = CreateFrame("BUTTON", "RaidMarker8Skull",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMSkull:SetSize(32,32)
     	WMSkull:SetPoint("CENTER")
     	WMSkull:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_8.png")
	WMSkull:SetAlpha(0.5)
    	WMSkull:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMSkull:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMSkull:RegisterForClicks("AnyUp")
	
	WMSkull:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMSkull:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",8) end\n/wm [btn:2] 0')

--Square Marks Raid Marker 6; World Marker 1
local WMSquare = CreateFrame("BUTTON", "WorldMarker1Square",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMSquare:SetSize(32,32)
     	WMSquare:SetPoint("RIGHT")
     	WMSquare:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_6.png")
	WMSquare:SetAlpha(0.5)
    	WMSquare:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMSquare:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMSquare:RegisterForClicks("AnyUp")
	
	WMSquare:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMSquare:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",6) end\n/wm [btn:2] 1')

--Cross Marks Raid Marker 7; World Marker 4
local WMCross = CreateFrame("BUTTON", "WorldMarker4Cross",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMCross:SetSize(32,32)
     	WMCross:SetPoint("BOTTOMLEFT")
     	WMCross:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_7.png")
	WMCross:SetAlpha(0.5)
    	WMCross:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMCross:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMCross:RegisterForClicks("AnyUp")
	
	WMCross:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMCross:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",7) end\n/wm [btn:2] 4')

--Moon Marks Raid Marker 5; NO World Marker
local WMMoon = CreateFrame("BUTTON", "RaidMarker5Moon",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMMoon:SetSize(32,32)
     	WMMoon:SetPoint("BOTTOM")
     	WMMoon:SetNormalTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_5.png")
	WMMoon:SetAlpha(0.5)
    	WMMoon:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMMoon:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMMoon:RegisterForClicks("AnyUp")
	
	WMMoon:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMMoon:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target",5) end\n/wm [btn:2] 0')

--Clear Marks Raid Marker 0; World Marker 6
local WMClear = CreateFrame("BUTTON", "WorldMarker6Clear",DejaMarkFrame, "SecureActionButtonTemplate")
     	WMClear:SetSize(32,32)
     	WMClear:SetPoint("BOTTOMRIGHT")
     	WMClear:SetNormalTexture("Interface\\BUTTONS\\UI-GroupLoot-Pass-Up")
	WMClear:SetAlpha(0.5)
    	WMClear:SetScript("OnEnter", function(self)
		self:SetAlpha(1)
	end)
    	WMClear:SetScript("OnLeave", function(self)
		self:SetAlpha(0.5)
	end)
	WMClear:RegisterForClicks("AnyUp")
	
	WMClear:SetAttribute("type","macro") -- /tm on left click, /wm on right click
	WMClear:SetAttribute("macrotext","/tm [btn:1] 0\n/cwm [btn:2] all")

-- toggle frame, has no visible parts. exists as a place to accept a click run a snippet
local toggleframe = CreateFrame("Button","DejaMark",UIParent,"SecureHandlerClickTemplate")
	toggleframe:RegisterForClicks("AnyUp", "AnyDown")
	toggleframe:SetFrameRef("ParentFrame",DejaMarkFrame)
	toggleframe:SetAttribute("_onclick",[[
	ParentFrame = self:GetFrameRef("ParentFrame")
  	if down then
		ParentFrame:SetPoint("CENTER","$cursor")
    		ParentFrame:Show()
  	else
    		ParentFrame:Hide()
  	end
]])

--BSC
--All credit to Bob.
--Bob's Stupid Castbar (aka BSC)
--Config
--Available fonts are ARIALN.ttf, FRIZQT__.ttf, MORPHEUS.ttf, SKURRI.ttf
                                
local font = "Fonts\\FRIZQT__.ttf"
local style = "nil" --OUTLINE MONOCHROME ect

--[[Player castbar]]--
local height = 16
local width = 180
local Point = "CENTER"
local positionX = 0
local positionY = -98
local textsize = height-2 --So the text scales with the Bar height
local Iconsize = 16

--[[target castbar]]--
local height2 = 16
local width2 = 180
local Point2 = "CENTER"
local positionX2 = 0
local positionY2 = 0
local textsize2 = height2-2
local Iconsize2 = 16

--[[focus castbar]]--Size is affected by the toggle option "Larger Focus Frame"
local height3 = 16
local width3 = 120
local Point3 = "TOP"
local positionX3 = 0
local positionY3 = 10
local textsize3 = height3-2
local Iconsize3 = 16
--------------------------------------------------------------------------------------------------
------------------------------------------[[END CONFIG]]------------------------------------------
--------------------------------------------------------------------------------------------------
local cbf = "CastingBarFrame"
local tbf = "TargetFrameSpellBar"
local fbf = "FocusFrameSpellBar"

--Player castbar
_G[cbf]:SetSize(width,height)
_G[fbf.."Border"]:SetSize(240,40)
_G[cbf.."Border"]:SetPoint("TOP", _G[cbf], 0, 15)
_G[cbf.."Border"]:SetTexture(nil)
_G[cbf.."Flash"]:SetSize(240,40)
_G[cbf.."Flash"]:SetPoint("TOP", _G[cbf], 0, 15)
_G[cbf.."Flash"]:SetTexture(nil)
_G[cbf]:SetScale("1.0")
_G[cbf.."Text"]:SetPoint("BOTTOM", _G[cbf], 0, -5)
_G[cbf.."Text"]:SetFont(font, textsize, style)
_G[cbf]:ClearAllPoints()
_G[cbf]:SetPoint(Point, UIParent, positionX, positionY)
_G[cbf].SetPoint = function() end
_G[cbf.."Icon"]:Show()
_G[cbf.."Icon"]:SetHeight(Iconsize)
_G[cbf.."Icon"]:SetWidth(Iconsize)

--Target Castbar
_G[tbf]:SetSize(width2,height2)
_G[tbf.."Border"]:SetSize(240,40)
_G[tbf.."Border"]:SetPoint("TOP", _G[tbf], 0, 15)
_G[tbf.."Border"]:SetTexture(nil)
_G[tbf.."Flash"]:SetSize(240,40)
_G[tbf.."Flash"]:SetPoint("TOP", _G[tbf], 0, 15)
_G[tbf.."Flash"]:SetTexture(nil)
_G[tbf]:SetScale("1.0")
_G[tbf.."Text"]:SetPoint("BOTTOM", _G[tbf], 0, -2)
_G[tbf.."Text"]:SetFont(font, textsize2, style)
_G[tbf]:ClearAllPoints()
_G[tbf]:SetPoint(Point2, UIParent, positionX2, positionY2)
_G[tbf].SetPoint = function() end
_G[tbf.."Icon"]:Show()
_G[tbf.."Icon"]:SetHeight(Iconsize2)
_G[tbf.."Icon"]:SetWidth(Iconsize2)

--Focus Castbar
_G[fbf]:SetSize(width3,height3)
_G[fbf.."Border"]:SetSize(240,40)
_G[fbf.."Border"]:SetPoint("TOP", _G[fbf], 0, 15)
_G[fbf.."Border"]:SetTexture(nil)
_G[fbf.."Flash"]:SetSize(240,40)
_G[fbf.."Flash"]:SetPoint("TOP", _G[fbf], 0, 15)
_G[fbf.."Flash"]:SetTexture(nil)
_G[fbf]:SetScale("1.0")
_G[fbf.."Text"]:SetPoint("BOTTOM", _G[fbf], 0, -2)
_G[fbf.."Text"]:SetFont(font, textsize3, style)
_G[fbf]:ClearAllPoints()
_G[fbf]:SetPoint(Point3, FocusFrame, "TOP", positionX3, positionY3)
_G[fbf].SetPoint = function() end
_G[fbf.."Icon"]:Show()
_G[fbf.."Icon"]:SetHeight(Iconsize3)
_G[fbf.."Icon"]:SetWidth(Iconsize3)

--Castbar timer from thek
_G[cbf].timer = _G[cbf]:CreateFontString(nil)
_G[cbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[cbf].timer:SetPoint("RIGHT", _G[cbf], "RIGHT", 24, 0)
_G[cbf].update = .1
_G[tbf].timer = _G[tbf]:CreateFontString(nil)
_G[tbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[tbf].timer:SetPoint("RIGHT", _G[tbf], "RIGHT", 24, 0)
_G[tbf].update = .1
_G[fbf].timer = _G[fbf]:CreateFontString(nil)
_G[fbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[fbf].timer:SetPoint("RIGHT", _G[fbf], "RIGHT", 24, 0)
_G[fbf].update = .1
hooksecurefunc("CastingBarFrame_OnUpdate", function(self, elapsed)
	if not self.timer then return end
	if self.update and self.update < elapsed then
		if self.casting then
			self.timer:SetText(format("%.1f", max(self.maxValue - self.value, 0)))
		elseif self.channeling then
			self.timer:SetText(format("%.1f", max(self.value, 0)))
		else
			self.timer:SetText("")
		end
		self.update = .1
	else
		self.update = self.update - elapsed
	end
end)

function dvshow()
	dvb:Show()
	dvdbframe:Show()
	statframep:Show()
	dvpetframe:Show()
	dvstanceframe:Show()
	dvrsbframe:Show()
	dvmmframe:Show()
	dvbagframe:Show()
	dvgttframe:Show()
	Minimap:RegisterForDrag("RightButton")
end

function dvhide()
	dvb:Hide()
	dvdbframe:Hide()
	statframep:Hide()
	dvpetframe:Hide()
	dvstanceframe:Hide()
	dvrsbframe:Hide()
	dvmmframe:Hide()
	dvbagframe:Hide()
	dvgttframe:Hide()
	Minimap:RegisterForDrag()
end

-- Lock/Unlock Frames
	dvlockcheck:SetScript("OnClick", function(self,event,arg1) 
		if self:GetChecked(true) then
			dvhide()
		else
			dvshow()
		end
	end)
	
do
	local function get_panel_name(panel)
		local tp = type(panel)
		local cat = INTERFACEOPTIONS_ADDONCATEGORIES
		if tp == "string" then
			for i = 1, #cat do
				local p = cat[i]
				if p.name == panel then
					if p.parent then
						return get_panel_name(p.parent)
					else
						return panel
					end
				end
			end
		elseif tp == "table" then
			for i = 1, #cat do
				local p = cat[i]
				if p == panel then
					if p.parent then
						return get_panel_name(p.parent)
					else
						return panel.name
					end
				end
			end
		end
	end

	local function InterfaceOptionsFrame_OpenToCategory_Fix(panel)
		if doNotRun or InCombatLockdown() then return end
		local panelName = get_panel_name(panel)
		if not panelName then return end -- if its not part of our list return early
		local noncollapsedHeaders = {}
		local shownpanels = 0
		local mypanel
		local t = {}
		local cat = INTERFACEOPTIONS_ADDONCATEGORIES
		for i = 1, #cat do
			local panel = cat[i]
			if not panel.parent or noncollapsedHeaders[panel.parent] then
				if panel.name == panelName then
					panel.collapsed = true
					t.element = panel
					InterfaceOptionsListButton_ToggleSubCategories(t)
					noncollapsedHeaders[panel.name] = true
					mypanel = shownpanels + 1
				end
				if not panel.collapsed then
					noncollapsedHeaders[panel.name] = true
				end
				shownpanels = shownpanels + 1
			end
		end
		local Smin, Smax = InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
		if shownpanels > 15 and Smin < Smax then 
		  local val = (Smax/(shownpanels-15))*(mypanel-2)
		  InterfaceOptionsFrameAddOnsListScrollBar:SetValue(val)
		end
		doNotRun = true
		InterfaceOptionsFrame_OpenToCategory(panel)
		doNotRun = false
	end

	hooksecurefunc("InterfaceOptionsFrame_OpenToCategory", InterfaceOptionsFrame_OpenToCategory_Fix)
end

--DV Slash Setup
local RegisteredEvents = {};
local dvslash = CreateFrame("Frame", "DejaViewSlash", UIParent)

dvslash:SetScript("OnEvent", function (self, event, ...) 
	if (RegisteredEvents[event]) then 
	return RegisteredEvents[event](self, event, ...) 
	end 
end)

function RegisteredEvents:ADDON_LOADED(event, addon, ...)
	if (addon == "DejaView") then
		SLASH_DEJAVIEW1 = '/dejaview'
		SlashCmdList["DejaView"] = function (msg, editbox)
			DejaView.SlashCmdHandler(msg, editbox)	
		end
		DEFAULT_CHAT_FRAME:AddMessage("DejaView loaded successfully. Type /dejaview for usage",0,192,255)
	end
end

for k, v in pairs(RegisteredEvents) do
	dvslash:RegisterEvent(k)
end

function DejaView.ShowHelp()
	print("DejaView Slash commands (/dejaview):")
	print("  /dejaview lock: Locks all DejaView movable frames.")
	print("  /dejaview unlock: Unlocks all DejaView movable frames.")
	print("  /dejaview config: Open the DejaView addon config menu.")
end

function DejaView.SetConfigToDefaults()
	print("Resetting config to defaults")
	DejaViewDBPC = DefaultConfig
	ReloadUI()
end

function DejaView.GetConfigValue(key)
	return DejaViewDBPC[key]
end

function DejaView.PrintPerformanceData()
	UpdateAddOnMemoryUsage()
	local mem = GetAddOnMemoryUsage("DejaView")
	print("DejaView is currently using " .. mem .. " kbytes of memory")
	collectgarbage(collect)
	UpdateAddOnMemoryUsage()
	mem = GetAddOnMemoryUsage("DejaView")
	print("DejaView is currently using " .. mem .. " kbytes of memory after garbage collection")
end

function DejaView.SlashCmdHandler(msg, editbox)
	--print("command is " .. msg .. "\n")
	if (string.lower(msg) == "config") then
		InterfaceOptionsFrame_OpenToCategory("DejaView");
	elseif (string.lower(msg) == "dumpconfig") then
		print("With defaults")
		for k,v in pairs(DVDefaultConfig) do
			print(k,DejaView.GetConfigValue(k))
		end
		print("Direct table")
		for k,v in pairs(DVDefaultConfig) do
			print(k,v)
		end
	elseif (string.lower(msg) == "lock") then
		dvhide()
		dvlockcheck:SetChecked(true)
	elseif (string.lower(msg) == "unlock") then
		dvshow()
		dvlockcheck:SetChecked(false)
	elseif (string.lower(msg) == "reset") then
		DejaViewDBPC = DefaultConfig;
	elseif (string.lower(msg) == "perf") then
		DejaView.PrintPerformanceData()
	else
		DejaView.ShowHelp()
	end
end
	SlashCmdList["DEJAVIEW"] = DejaView.SlashCmdHandler;